<template>
  <v-btn icon v-bind="$attrs" @click="download">
    <v-icon v-text="'mdi-download'"/>
  </v-btn>
</template>

<script>
  import { getMedia } from '@/utils/media'
  import handlingErrors from '@/error/handling'

  export default {
    props: ['url', 'mediaId'],
    methods: {
      async download () {
        const a = document.createElement('a')
        try {
          a.href = await this.getUrl()
          a.target = '_blank'
          a.download = 'audio'
          a.dispatchEvent(new MouseEvent('click'))
        } catch (e) { console.error(e) }
      },
      getUrl () {
        if (this.url) return this.url
        return getMedia(this.mediaId)
          .then(r => r.data.url)
          .catch(e => handlingErrors(e))
      }
    }
  }
</script>
